
#     this is loaded into the DataAcquisitionControl namespace

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable INFO ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable allservers 0


    variable JS ""
    variable INFO ""


   proc  show_variables {} {
       variable allservers

       InsertLog "allservers=$allservers"
       InsertLog "AcqServer=$::DataAcquisition::ACQSERVER"
   }

    proc do_setup {} {
        variable allservers

        if {$allservers == 1} {set Option "SetUp=All"} else {set Option "SetUp=$::DataAcquisition::ACQSERVER"}

      set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoOption "$Option"} m]

        if {$rc != 0} {
            InsertLog "DoOption returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "DoOption returned $m ([format "0x%x" $m])"
            InsertLog "DoOption returned $m"
        }

    }

    proc do_resync {} {
        variable allservers

        if {$allservers == 1} {set Option "ReSync=All"} else {set Option "ReSync=$::DataAcquisition::ACQSERVER"}

      set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoOption "$Option"} m]

        if {$rc != 0} {
            InsertLog "DoOption returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "DoOption returned $m ([format "0x%x" $m])"
            InsertLog "DoOption returned $m"
        }
    }
 
     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {
                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   DORESYNC    {do_resync}
                   DOSETUP     {do_setup}

                   UPDATESTATE -
                   UPDATE    {}

                   SERVER     {set ::DataAcquisition::ACQSERVER $vl}
                   ALLSERVERS {variable allservers; set allservers [expr ($allservers + 1) & 1]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
       }

    }

}   ;# end of if {$started == 0}




